
class Vector{
  
  final float x,y,z;
  
  Vector(float x,float y,float z){
    this.x=x;
    this.y=y;
    this.z=z;  
  }
  
  Vector multiply(float scalar){
      return new Vector(x * scalar, y*scalar,z*scalar);
  }
  
  Vector devide(float scalar){
    return new Vector(x / scalar, y/scalar,z/scalar);
  }
  
  Vector add(Vector other){
    return new Vector(x + other.x,y + other.y,z + other.z);
  }
  
  Vector subtract(Vector other){
    return new Vector(x - other.x,y-other.y,z-other.z);
  }
  
  float distanceTo(Vector other){
    return (float) Math.pow((x - other.x) * (x - other.x) + (y - other.y) * (y - other.y) + (z - other.z) * (z - other.z),0.5);
  }
  
  Vector normalize(){
    if(size()==0.0)
      return this;
    else
      return devide(size());
  }
  
  float size(){
    return distanceTo(new Vector(0,0,0));
  }
  
  public String toString(){
    return x + "\t,\t" + y + "\t,\t" + z;
  }   
  
  public float getXAngle(){
      return acos(x/size());
  }
  
  public float getYAngle(){
      return acos(y/size());
  }
  
  public float getZAngle(){
      return acos(z/size());
  }
}
